﻿Function Compress-Directory {
    [CmdletBinding()]
    Param (
        [Parameter(Mandatory=$true)]
        [String]$SourceDirectory,
        
        [Parameter(Mandatory=$true)]
        [String]$ArchiveFileName
    )
    Add-Type -Assembly System.IO.Compression.FileSystem
    $SourceDirectory = (Resolve-Path $SourceDirectory).Path

    [System.IO.Compression.ZipFile]::CreateFromDirectory(
        $SourceDirectory,$ArchiveFileName,'Optimal',$false)
}

Function Expand-ZipFile {
    [CmdletBinding()]
    Param (
        [Parameter(Mandatory=$true)]
        [String]$ArchiveFileName,
        
        [Parameter(Mandatory=$true)]
        [String]$DestinationDirectory
    )
    Add-Type -Assembly System.IO.Compression.FileSystem
    [System.IO.Compression.ZipFile]::ExtractToDirectory(
        $ArchiveFileName, $DestinationDirectory)
}