﻿# Get-ComputerAccountLastLogon.ps1

function ConvertTo-LocalTime
{
    [CmdletBinding()]
    Param ( 
       [Parameter(Mandatory=$true)]
       [Int64]$LongDate 
    )
    $myUTCTime = ([DateTime]$LongDate).AddYears(1600)
    [TimeZoneInfo]::ConvertTimeFromUtc($myUTCTime, [TimeZoneInfo]::Local)
} 

$comptes = Get-ADComputer -Filter *  `
                          -Properties name,LastLogonTimeStamp,OperatingSystem, 
                            OperatingSystemVersion,OperatingSystemServicePack,
                            OperatingSystemServicePack

$comptes | Select-Object @{e={$_.Name};n='ComputerName'},
                         @{e={ConvertTo-LocalTime $_.LastLogonTimeStamp};
                           n='LastLogon'},
                         @{e={$_.OperatingSystem};n='OSName'},
                         @{e={$_.OperatingSystemVersion};n='OSVersion'},
                         @{e={$_.OperatingSystemServicePack};n='OSServicePack'}