﻿# Get-ExpiredCertificate.ps1

$liste = Get-ADComputer -Filter * | Foreach {$_.Name}
$Script = {
   $DateLimite = (Get-Date).AddDays(30);
   Gci Cert:\LocalMachine\My | Where {$_.notafter -lt $DateLimite} | 
       Select @{Label="Hostname" ; Expression={$Env:ComputerName}},
              Subject, NotAfter, 
              @{Label="Expires In (Days)"; Expression={($_.NotAfter - (Get-Date)).Days}} 
}

Invoke-Command –ComputerName $liste –ScriptBlock $Script | 
    Format-Table Hostname,Subject,NotAfter,Expire*