﻿# Get-MediaPlayerVersion.ps1
function Get-Key
{   
   #Accès à la base de registre
   $Version = (Get-ItemProperty HKLM:\SOFTWARE\Microsoft\MediaPlayer\PlayerUpgrade `
-Name "PlayerVersion" –ea silentlycontinue).PlayerVersion

   if ($Version -eq $null)
   { 
      $Version="Non Installé"
   }
   return $Version
}

# Requête Active Directory
$listeMachines = Get-ADComputer -Filter * | Foreach {$_.Name}

foreach ($Machine in $listeMachines)
{
   if (Test-Connection $Machine -quiet -count 1) # test de connexion (ping)
   {
      $version = invoke-Command $Machine -scriptblock ${function:Get-Key}
   }
   else
   {
      $version = 'Machine non joignable'
   }
   [PSCustomObject]@{Machine = $machine; Version = $version}
}
