﻿# Get-UserAccountLastLogon.ps1
function ConvertTo-LocalTime
{
    [CmdletBinding()]
    Param ( 
       [Parameter(Mandatory=$true)]
       [Int64]$LongDate 
    )

    $myUTCTime = ([DateTime]$LongDate).AddYears(1600)
    [TimeZoneInfo]::ConvertTimeFromUtc($myUTCTime, [TimeZoneInfo]::Local)
} 

$comptes = Get-ADUser -Filter * `
    -Properties Name,WhenCreated,HomeDrive,HomeDirectory,LastLogonTimestamp

$comptes | Select-Object Name, WhenCreated, HomeDrive, HomeDirectory,
            @{e={ConvertTo-LocalTime $_.lastlogontimestamp};n='LastLogon'}