﻿# Get-UserAccountLastLogonv2.ps1 
[CmdletBinding()]
Param (
    [Parameter(Mandatory=$false)]
    [int]$NotConnectedSinceNDays = 90
)

function ConvertTo-LocalTime
{
    [CmdletBinding()]
    Param ( 
       [Parameter(Mandatory=$true)]
       [Int64]$LongDate 
    )

    $myUTCTime = ([DateTime]$LongDate).AddYears(1600)
    [TimeZoneInfo]::ConvertTimeFromUtc($myUTCTime, [TimeZoneInfo]::Local)
} 

$comptes = Get-ADUser -Filter * `
    -Properties Name,WhenCreated,HomeDrive,HomeDirectory,LastLogonTimestamp

$comptes | Select-Object Name, WhenCreated, HomeDrive, HomeDirectory,
            @{e={ConvertTo-LocalTime $_.lastlogontimestamp};n='LastLogon'} |
           Where {
       (New-TimeSpan -Start $_.LastLogon -End (Get-Date) ).TotalDays `
            -ge $NotConnectedSinceNDays -and 
             $_.LastLogon -ne [DateTime]'01/01/1601 01:00:00'}
