﻿Function Set-LocalAdminPassword 
{
   [CmdletBinding()]
   Param (
       [Alias("CN","MachineName")]
       [Parameter(Mandatory=$true, ValueFromPipeline=$true,
       HelpMessage="Nom d'ordinateur obligatoire !")]
       [String[]]$ComputerName,
       [Parameter(Mandatory=$true, 
       HelpMessage="Mot de passe obligatoire !")]
       [String]$password
   )

   Process {
       $ComputerName | ForEach {       
           $objAdminUser = [ADSI]"WinNT://$_/Administrateur,user"
           $objAdminUser.SetPassword($password)
           if ($?)
           {
              Write-Verbose "$_ : Le mot de passe a été changé"
           }
           else
           {
              Write-Error "$_ : Impossible de changer le mot de passe !"
           }
       }
   }
}