﻿# Watch-DomainAdminsGroup.ps1
$action = {
   $evt = Get-WinEvent -FilterHashtable @{Logname="Security"; ID="4728"} -MaxEvents 1
   if ( $evt.message -match 'Nom du groupe\W\:\W+Admins du domaine')
   {
      $msg = @"
   Evénement détecté à : {0} 
   Date de l'entrée dans le journal : {1}
   Contenu de l'événement : {2}
"@  -f (ConvertTo-LocalTime `
            -LongDate $event.SourceEventArgs.NewEvent.Time_Created),
       $evt.TimeCreated,
       $evt.Message

      Send-MailMessage -SmtpServer 'ExchangeSrv' `
                       -From 'Alerte@ps-scripting.com' `
                       -To 'Admins@ps-scripting.com' `
                       -Subject 'Ajout de membre dans le groupe Admins du domaine !' `
                       -Body $msg `
                       -Encoding Unicode
   }
}
$query = "SELECT * FROM __InstanceCreationEvent
             WITHIN 30 
             WHERE Targetinstance ISA 'Win32_NTLogEvent'  
             AND TargetInstance.EventCode = '4728'"

Register-CimIndicationEvent -Query $query -SourceIdentifier "SpyWatcher" `
                            -Action $action  