﻿# Définition d'un alias personnalisé
Set-alias -name grep -value Select-String 
 
# Définition des fonctions 
function IsAdmin 
{ 
   $CurrentUser =  
      [System.Security.Principal.WindowsIdentity]::GetCurrent() 
   $principal =  
      New-Object System.Security.principal.windowsprincipal($CurrentUser) 
   $principal.IsInRole( ` 
      [System.Security.Principal.WindowsBuiltInRole]::Administrator) 
} 
 
# Modification des variables de préférence 
$VerbosePreference = 'Continue' 
$DebugPreference   = 'Continue' 
 
# Message d'accueil personnalisé 
# 
if (isAdmin) { 
    $ElevationMode = 'Privilégiée' 
    $host.UI.RawUI.BackGroundColor = 'DarkRed' 
    Clear-Host 
} 
else { 
    $ElevationMode = 'Non Privilégiée' 
    $host.UI.RawUI.BackGroundColor = 'DarkMagenta' 
    Clear-Host 
} 
 
$CurrentUser =  
   [System.Security.Principal.WindowsIdentity]::GetCurrent() 
 
Write-Host '+---------------------------------------------------+' 
Write-Host ("+- Bonjour {0} " -f ($CurrentUser.Name).split('\')[1]) 
Write-Host '+---------------------------------------------------+' 
 
# Modification de la couleur du prompt en jaune, remplacement 
# du Prompt par PS > et affichage du chemin courant dans la barre de titre 
# de la fenêtre de la console 
function prompt  
{ 
    Write-Host ('PS ' + '>') -NoNewline -ForegroundColor yellow 
    $host.UI.RawUI.Set_windowtitle("$(Get-Location) [$ElevationMode]") 
    ' ' 
}
